# Trinsic-Api
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: v1
- Package version: 0.3.0
- Generator version: 7.7.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import trinsic-api
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import trinsic-api
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import trinsic-api
from trinsic-api.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://api.trinsic.id
# See configuration.py for a list of all supported configuration parameters.
configuration = trinsic-api.Configuration(
    host = "https://api.trinsic.id"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure Bearer authorization: Bearer
configuration = trinsic-api.Configuration(
    access_token = os.environ["BEARER_TOKEN"]
)


# Enter a context with an instance of the API client
with trinsic-api.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = trinsic-api.AttachmentsApi(api_client)
    exchange_attachment_access_key_request = trinsic-api.ExchangeAttachmentAccessKeyRequest() # ExchangeAttachmentAccessKeyRequest |  (optional)

    try:
        # Exchange an Attachment Access Key (from `IdentityData.Attachments`) for the raw contents of the attachment.                Use this API to fetch document (front, back, portrait) or other (selfie) images from a verification, if relevant.                In some cases, attachments may not be immediately available after a verification is completed. If so, this endpoint will return an HTTP 202 code, and you should try again later.
        api_instance.exchange_attachment_access_key(exchange_attachment_access_key_request=exchange_attachment_access_key_request)
    except ApiException as e:
        print("Exception when calling AttachmentsApi->exchange_attachment_access_key: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.trinsic.id*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AttachmentsApi* | [**exchange_attachment_access_key**](docs/AttachmentsApi.md#exchange_attachment_access_key) | **POST** /api/v1/attachments/exchange | Exchange an Attachment Access Key (from &#x60;IdentityData.Attachments&#x60;) for the raw contents of the attachment.                Use this API to fetch document (front, back, portrait) or other (selfie) images from a verification, if relevant.                In some cases, attachments may not be immediately available after a verification is completed. If so, this endpoint will return an HTTP 202 code, and you should try again later.
*NetworkApi* | [**identity_lookup**](docs/NetworkApi.md#identity_lookup) | **GET** /api/v1/network/identities/{phoneNumber} | Query the availability of an identity in the Trinsic Network by phone number
*NetworkApi* | [**list_providers**](docs/NetworkApi.md#list_providers) | **GET** /api/v1/network/providers | List all identity providers available for use
*SessionsApi* | [**cancel_session**](docs/SessionsApi.md#cancel_session) | **POST** /api/v1/sessions/{sessionId}/cancel | Cancel a Session by its ID
*SessionsApi* | [**create_session**](docs/SessionsApi.md#create_session) | **POST** /api/v1/sessions | Create a Session to verify a user&#39;s identity
*SessionsApi* | [**exchange_results_key**](docs/SessionsApi.md#exchange_results_key) | **POST** /api/v1/sessions/{sessionId}/results/exchange | Exchange a Results Access Key for Identity Data
*SessionsApi* | [**get_session**](docs/SessionsApi.md#get_session) | **GET** /api/v1/sessions/{sessionId} | Get a Session by its ID
*SessionsApi* | [**list_sessions**](docs/SessionsApi.md#list_sessions) | **GET** /api/v1/sessions | List Sessions created by your account
*SessionsApi* | [**redact_session**](docs/SessionsApi.md#redact_session) | **POST** /api/v1/sessions/{sessionId}/redact | Redact a Session, removing all identity data from Trinsic&#39;s servers.                Identity data that a user has chosen to save in their passkey-protected wallet will not be deleted.


## Documentation For Models

 - [Address](docs/Address.md)
 - [Attachments](docs/Attachments.md)
 - [CancelSessionResponse](docs/CancelSessionResponse.md)
 - [CreateSessionRequest](docs/CreateSessionRequest.md)
 - [CreateSessionResponse](docs/CreateSessionResponse.md)
 - [DisclosedFields](docs/DisclosedFields.md)
 - [DisclosedFieldsRequest](docs/DisclosedFieldsRequest.md)
 - [DocumentData](docs/DocumentData.md)
 - [ExchangeAttachmentAccessKeyRequest](docs/ExchangeAttachmentAccessKeyRequest.md)
 - [ExchangeResultsKeyRequest](docs/ExchangeResultsKeyRequest.md)
 - [ExchangeResultsKeyResponse](docs/ExchangeResultsKeyResponse.md)
 - [FailureMessage](docs/FailureMessage.md)
 - [GetSessionResponse](docs/GetSessionResponse.md)
 - [IdentityData](docs/IdentityData.md)
 - [IdentityLookupResponse](docs/IdentityLookupResponse.md)
 - [ListProvidersResponse](docs/ListProvidersResponse.md)
 - [ListSessionsResponse](docs/ListSessionsResponse.md)
 - [OrderDirection](docs/OrderDirection.md)
 - [PersonData](docs/PersonData.md)
 - [ProviderInfo](docs/ProviderInfo.md)
 - [Session](docs/Session.md)
 - [SessionFailCode](docs/SessionFailCode.md)
 - [SessionOrdering](docs/SessionOrdering.md)
 - [SessionState](docs/SessionState.md)
 - [ValidationResult](docs/ValidationResult.md)
 - [Verification](docs/Verification.md)
 - [VerificationFailCode](docs/VerificationFailCode.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="Bearer"></a>
### Bearer

- **Type**: Bearer authentication


## Author




